#!/bin/sh

path=../tools

btormc=$path/btormc
btorsim=$path/btorsim

invalid () {
  echo invalid
}

set -x

 mkdir -p out
 $btormc    -kmax 20  count2.btor                  > out/count2.witnessmc
 $btormc    -kmax 20  count4.btor                  > out/count4.witnessmc
 $btormc    -kmax 20  factorial4even.btor          > out/factorial4even.witnessmc
 $btormc    -kmax 20  noninitstate.btor            > out/noninitstate.witnessmc
 $btormc    -kmax 20  recount4.btor                > out/recount4.witnessmc
 $btormc    -kmax 20  twocount2.btor               > out/twocount2.witnessmc
 $btormc    -kmax 20  twocount2c.btor              > out/twocount2c.witnessmc
 $btormc    -kmax 20  twocount32.btor              > out/twocount32.witnessmc
           
 $btorsim -b 0 -r 20  count2.btor                  > out/count2.witnesssim
 $btorsim -b 0 -r 20  count4.btor                  > out/count4.witnesssim
 $btorsim -b 0 -r 20  factorial4even.btor          > out/factorial4even.witnesssim
 $btorsim -b 0 -r 20  noninitstate.btor -s 1       > out/noninitstate.witnesssim
 $btorsim -b 0 -r 20  twocount2.btor               > out/twocount2.witnesssim
 $btorsim -b 0 -r 20  twocount2c.btor   -s 11      > out/twocount2c.witnesssim
 $btorsim -b 0 -r 20  twocount32.btor              > out/twocount32.witnesssim

           
 $btorsim      -c     count2.btor                    out/count2.witnessmc
 $btorsim      -c     count4.btor                    out/count4.witnessmc
 $btorsim      -c     factorial4even.btor            out/factorial4even.witnessmc
 $btorsim      -c     noninitstate.btor              out/noninitstate.witnessmc
 $btorsim      -c     recount4.btor                  out/recount4.witnessmc
 $btorsim      -c     twocount2.btor                 out/twocount2.witnessmc
 $btorsim      -c     twocount2c.btor                out/twocount2c.witnessmc
 $btorsim      -c     twocount32.btor                out/twocount32.witnessmc
           
 $btorsim      -c     count2.btor                    out/count2.witnesssim
 $btorsim      -c     count4.btor                    out/count4.witnesssim
 $btorsim      -c     factorial4even.btor            out/factorial4even.witnesssim
 $btorsim      -c     noninitstate.btor              out/noninitstate.witnesssim
 $btorsim      -c     twocount2.btor                 out/twocount2.witnesssim
 $btorsim      -c     twocount2c.btor                out/twocount2c.witnesssim
 $btorsim      -c     twocount32.btor                out/twocount32.witnesssim

 $btorsim -b 0 -r 20  noninitstate.btor            > out/noninitstate.nowitnesssim
 $btorsim      -c     noninitstate.btor              out/noninitstate.nowitnesssim 2>/dev/null && invalid

 $btorsim -b 0 -r 20  recount4.btor                > out/recount4.nowitnesssim
 $btorsim      -c     recount4.btor                  out/recount4.witnesssim       2>/dev/null && invalid

 $btorsim -b 0 -r 20  twocount2c.btor              > out/twocount2c.witnesssim
 $btorsim      -c     twocount2c.btor                out/twocount2c.witnesssim     2>/dev/null && invalid



 $btorsim -b 0 -r 999 ponylink-slaveTXlen-sat.btor > out/ponylink-slaveTXlen.nowitnesssim
 $btorsim      -c     ponylink-slaveTXlen-sat.btor   out/ponylink-slaveTXlen.nowitnesssim 2>/dev/null && invalid

 $btormc    -kmax 229 ponylink-slaveTXlen-sat.btor > out/ponylink-slaveTXlen.witnessmc
 $btorsim      -c     ponylink-slaveTXlen-sat.btor   out/ponylink-slaveTXlen.witnessmc
