#!/bin/sh
#SBATCH -e /dev/null
#SBATCH -o /dev/null
#SBATCH -c 32
#SBATCH -a 1-10
#SBATCH -D /home/mathias/runs/2018-01-31-bmc-unrolled-boolector-2nd

prefix="/home/mathias/benchmarks/2018A/"
runlim_options="--time-limit=3600 --space-limit=7000"
solver="./boolector"
solver_options=" --incremental -v"
benchmarks="./benchmarks"

# pick benchmark file from list of benchmarks
benchmark=`sed ${SLURM_ARRAY_TASK_ID}'q;d' $benchmarks`
out="$(echo ${benchmark#$prefix} | sed -e 's,/,-,g' -e 's,\.smt.*,,')"
# set stdout log file
log="${out}.log"
# set stderr log file
err="${out}.err"

echo "c host: `hostname`" >> $log
echo "c start: `date`"
echo "c benchmark: $benchmark" >> $log
echo "c solver: $solver" >> $log
echo "c solver options: $solver_options" >> $log

$HOME/bin/runlim \
  $runlim_options \
  $solver \
  $solver_options \
  $benchmark >> $log 2> $err

echo "c launch: done" >> $log
